/* CalendarHelp internal component - Source at http://calendarhelp.mozdev.org - Subject to copyright and license terms */
CalHelpSidebar = {
box: null,button: null,splitter: null,toc: null,search: null,suffix: "",init: function () {
this.box = document.getElementById("help-sidebar");
this.button = document.getElementById("help-sidebar-button")
this.splitter = document.getElementById("help-sidebar-splitter")
this.toc = document.getElementById("help-toc-sidebar")
this.search = document.getElementById("help-search-sidebar")
this.suffix = document.documentElement.getAttribute("titlesuffix")
document.getElementById("context-reload").collapsed = true
document.getElementById("findText").addEventListener(
"command",function () {CalHelpSidebar.toggle(true)},false)
document.getElementById("help-content").addEventListener(
"DOMTitleChanged",function (event) {
var doc = event.target
var t = doc.title
if (t.length == 0) return
if (doc.location.href.indexOf("chrome://calendarhelp/") != 0) {
var p = CalHelpExtensions.prefix
if (t.indexOf(p) != 0) t = p + t
doc.getElementsByTagName("h1")[0].firstChild.nodeValue = t}
CalHelpSidebar.title = t},false)},contents: function (show) {
if (show) {
this.toc.removeAttribute("hidden")
this.search.setAttribute("hidden", "true")}
else {
this.search.removeAttribute("hidden")
this.toc.setAttribute("hidden", "true")}},resized: function () {
this.button.checked = this.box.collapsed},set title (t) {
if (t) document.title = t.indexOf(this.suffix) > 0 ? t : t + " - " + this.suffix},toggle: function (seen) {
with (this.box) {
if (seen == !collapsed) return;
if (seen == undefined) seen = collapsed;
collapsed = !seen;}
this.splitter.setAttribute("state", (seen ? "" : "collapsed"))
setTimeout("CalHelpSidebar.button.checked = " + !seen, 0)}}
CalHelpSearch = {
result: null,text: null,tree: null,suffix: "",nothing: "",RDF: Components.classes['@mozilla.org/rdf/rdf-service;1'].getService(Components.interfaces.nsIRDFService),CU: Components.classes['@mozilla.org/rdf/container-utils;1'].getService(Components.interfaces.nsIRDFContainerUtils),root: this.RDF.GetResource("urn:root"),subs: this.RDF.GetResource("http://home.netscape.com/NC-rdf#subheadings"),name: this.RDF.GetResource("http://home.netscape.com/NC-rdf#name"),link: this.RDF.GetResource("http://home.netscape.com/NC-rdf#link"),type: this.RDF.GetResource("http://home.netscape.com/NC-rdf#type"),child: this.RDF.GetResource("http://home.netscape.com/NC-rdf#child"),glossary: [],index: [],toc: [],init: function () {
this.text = document.getElementById("findText")
this.tree = document.getElementById("help-search-tree")
this.suffix = " " + this.tree.getAttribute("glossarysuffix")
this.nothing = this.tree.getAttribute("nothingfound")
window.doFind = function () {CalHelpSearch.doFind()}
var b = this.tree.getElementsByTagName("bindings")[0]
with (b.appendChild(document.createElement("binding"))) {
setAttribute("subject", "?subheading")
setAttribute("predicate", "http://home.netscape.com/NC-rdf#type")
setAttribute("object", "?type")}
this.tree.getElementsByTagName("treecell")[0].setAttribute("properties", "?type")},load: function () {
this._load(
this.glossary,document.getElementById("help-glossary-panel").database,this.root,"glossary")
this._load(
this.index,document.getElementById("help-index-panel").database,this.root,"index")
this._load(
this.toc,document.getElementById("help-toc-panel").database,this.root,"toc")},_load: function (a, ds, res, type, prefix) {
var t = ds.GetTarget(res, this.subs, true)
if (!t) return
var en = this.CU.MakeSeq(ds, t).GetElements()
while (en.hasMoreElements()) {
var r = en.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
var l = ds.GetTarget(r, this.link, true)
var n = ds.GetTarget(r, this.name, true)
if (n) {
n = n.QueryInterface(Components.interfaces.nsIRDFLiteral).Value
if (l) a.push({
type: type,name: prefix ? prefix + "," + n : n,link: l.QueryInterface(Components.interfaces.nsIRDFLiteral).Value})
this._load(a, ds, r, type, type == "index" && n.length > 1 ? n : "")}}},doFind: function () {
if (this.toc.length == 0) this.load()
var s = this.text.value.replace(/^\s+/, "").replace(/\s+$/, "").replace(/\s{2,}/, " ").replace(/[\\\^\$\+\*\?\[\]\(\)\{\}]/g, "")
this.text.value = s
if (s.length < 2) return
var re = new RegExp(s, "i")
var r = []
for each (var v in this.glossary) if (re.test(v.name)) r.push(v)
for each (var v in this.index) if (re.test(v.name)) r.push(v)
for each (var v in this.toc) if (re.test(v.name)) r.push(v)
if (this.result) this.tree.database.RemoveDataSource(this.result)
this.result = Components.classes["@mozilla.org/rdf/datasource;1?name=in-memory-datasource"].createInstance(Components.interfaces.nsIRDFDataSource)
if (r.length == 0) {
var res = this.RDF.GetAnonymousResource()
with (this.result) {
Assert(res, this.type, this.RDF.GetLiteral("empty"), true)
Assert(res, this.name, this.RDF.GetLiteral(this.nothing), true)
Assert(this.root, this.child, res, true)}
this.tree.setAttribute("empty", "true")}
else {
r.sort(function(a, b) {
var av = a.link, bv = b.link
if (av == bv) {
var p = {index: 2, glossary: 1, toc: 0}
av = p[a.type], bv = p[b.type]}
if (av == bv) av = b.name.length, bv = a.name.length
return (av == bv)? 0 : (av > bv)? 1 : -1})
var link = null
for each (var v in r) {
var l = v.link
if (link && l == link) v.link = null, v.name = ""
else link = l}
r.sort(function(a, b) {
var av = a.name.toLowerCase(), bv = b.name.toLowerCase()
return (av == bv)? 0 : (av > bv)? 1 : -1})
for each (var v in r) {
if (!v.link) continue
var res = this.RDF.GetAnonymousResource()
with (this.result) {
Assert(
res,this.type,this.RDF.GetLiteral(v.type),true)
Assert(
res,this.name,this.RDF.GetLiteral(v.name + (v.type == "glossary" ? this.suffix : "")),true)
Assert(
res,this.link,this.RDF.GetLiteral(v.link),true)
Assert(this.root, this.child, res, true)}}
this.tree.removeAttribute("empty")}
this.tree.database.AddDataSource(this.result)
this.tree.builder.rebuild()
CalHelpSidebar.contents(false)}}
CalHelpExtensions = {
RDF: Components.classes['@mozilla.org/rdf/rdf-service;1'].getService(Components.interfaces.nsIRDFService),CU: Components.classes['@mozilla.org/rdf/container-utils;1'].getService(Components.interfaces.nsIRDFContainerUtils),CR: Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService(Components.interfaces.nsIChromeRegistry),EM: Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager),IO: Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService),chIndex: "chrome://calendarhelp/locale/index.rdf#",chToC: "chrome://calendarhelp/locale/toc.rdf#",emManifest: RDF.GetResource("urn:mozilla:install-manifest"),emType: RDF.GetResource("http://www.mozilla.org/2004/em-rdf#type"),emDisabled: RDF.GetResource("http://www.mozilla.org/2004/em-rdf#userDisabled"),emHelp: RDF.GetResource("http://www.mozilla.org/2004/em-rdf#helpURL"),ncLink: RDF.GetResource("http://home.netscape.com/NC-rdf#link"),ncName: RDF.GetResource("http://home.netscape.com/NC-rdf#name"),ncSubs: RDF.GetResource("http://home.netscape.com/NC-rdf#subheadings"),chapter: [],todo: 0,loaded: false,prefix: "",init: function () {
var ds = null
if (!ds) ds = this.EM.datasource
var en = this.CU.MakeSeq(ds, this.RDF.GetResource("urn:mozilla:item:root")).GetElements()
while (en.hasMoreElements()) {
var r = en.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
var t = ds.GetTarget(r, this.emType, true)
if (t && t.QueryInterface(Components.interfaces.nsIRDFInt).Value == 2) {
t = ds.GetTarget(r, this.emDisabled, true)
if (!t || t.QueryInterface(Components.interfaces.nsIRDFLiteral).Value != "true") {
var id = r.Value.replace(/^[^\{]*/, "")
var loc = this.EM.getInstallLocation(id).getItemLocation(id)
loc.append("install.rdf")
var ids = this.RDF.GetDataSourceBlocking(this.IO.newFileURI(loc).spec)
t = ids.GetTarget(this.emManifest, this.emHelp, true)
if (t) this.loadChapter(t.QueryInterface(Components.interfaces.nsIRDFLiteral).Value)}}}
this.prefix = document.documentElement.getAttribute("extensionprefix")
this.loaded = (this.todo == 0)},loadChapter: function (spec) {
var url = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI)
url.spec = spec
var ctx = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString)
ctx.data = spec
this.IO.newChannelFromURI(url).asyncOpen({
onStartRequest: function (req, ctx) {
CalHelpExtensions.chapter[
ctx.QueryInterface(Components.interfaces.nsISupportsString).data
] = ""},onDataAvailable: function (req, ctx, inp, offset, count) {
var s = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
s.init(inp);
CalHelpExtensions.chapter[
ctx.QueryInterface(Components.interfaces.nsISupportsString).data
] += s.read(count)},onStopRequest: function (req, ctx) {
CalHelpExtensions.parseChapter(
ctx.QueryInterface(Components.interfaces.nsISupportsString).data)}},ctx)
this.todo++},parseChapter: function (spec) {
var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"].createInstance(Components.interfaces.nsIDOMParser)
var doc = parser.parseFromString(
this.chapter[spec].replace(/&/g, "&#38;"),"text/xml")
var toctree = document.getElementById("help-toc-panel")
var tocds = toctree.database
var en = tocds.GetDataSources()
while (en.hasMoreElements()) {
var ds = en.getNext().QueryInterface(Components.interfaces.nsIRDFDataSource)
if (ds.URI == "rdf:local-store") tocds.RemoveDataSource(ds)}
tocds.AddDataSource(Components.classes["@mozilla.org/rdf/datasource;1?name=in-memory-datasource"].createInstance(Components.interfaces.nsIRDFDataSource))
var name = spec.replace(/^chrome:\/\/|\/.*$/g, "")
var h = doc.getElementsByTagName("h1")[0]
var h1text = h.firstChild.nodeValue
if (!h1text) {
dump("CalHelpExtensions: " + name + " has no h1 text \n")
return}
var rootseq = this.CU.MakeSeq(
tocds,tocds.GetTarget(this.RDF.GetResource("urn:root"), this.ncSubs, true))
var h1res = RDF.GetResource(this.chToC + name + ":" + name)
if (this._alreadyHas(tocds, h1res)) return
rootseq.InsertElementAt(h1res, rootseq.GetCount() - 1, false)
tocds.Assert(h1res, this.ncName, RDF.GetLiteral(this.prefix + h1text.replace(/\s*$/, "")), true)
tocds.Assert(h1res, this.ncLink, RDF.GetLiteral(spec + "#" + name), true)
var h1seq = null, h2seq = null, h3seq = null
headings:
while (h = h.nextSibling) {
switch (h.localName) {
case "h1":
break headings
case "h2":
if (!h1res) break
if (!h1seq) {
h1seq = this.CU.MakeSeq(tocds, this.RDF.GetAnonymousResource())
tocds.Assert(h1res, this.ncSubs, h1seq.Resource, true)}
var h2res = RDF.GetResource(this.chToC + name + ":" + h.id)
if (this._alreadyHas(tocds, h2res)) break
h1seq.AppendElement(h2res)
tocds.Assert(h2res, this.ncName, RDF.GetLiteral(h.firstChild.nodeValue.replace(/\s*$/, "")), true)
tocds.Assert(h2res, this.ncLink, RDF.GetLiteral(spec + "#" + h.id), true)
h2seq = null, h3seq = null
break
case "h3":
if (!h2res) break
if (!h2seq) {
h2seq = this.CU.MakeSeq(tocds, this.RDF.GetAnonymousResource())
tocds.Assert(h2res, this.ncSubs, h2seq.Resource, true)}
var h3res = RDF.GetResource(this.chToC + name + ":" + h.id)
if (this._alreadyHas(tocds, h3res)) break
h2seq.AppendElement(h3res)
tocds.Assert(h3res, this.ncName, RDF.GetLiteral(h.firstChild.nodeValue.replace(/\s*$/, "")), true)
tocds.Assert(h3res, this.ncLink, RDF.GetLiteral(spec + "#" + h.id), true)
h3seq = null
break
case "h4":
if (!h3res) break
if (!h3seq) {
h3seq = this.CU.MakeSeq(tocds, this.RDF.GetAnonymousResource())
tocds.Assert(h3res, this.ncSubs, h3seq.Resource, true)}
var h4res = RDF.GetResource(this.chToC + name + ":" + h.id)
if (this._alreadyHas(tocds, h4res)) break
h3seq.AppendElement(h4res)
tocds.Assert(h4res, this.ncName, RDF.GetLiteral(h.firstChild.nodeValue.replace(/\s*$/, "")), true)
tocds.Assert(h4res, this.ncLink, RDF.GetLiteral(spec + "#" + h.id), true)
break
case "context":
break
case "index":
break}}
toctree.builder.rebuild()
var idxtree = document.getElementById("help-index-panel")
var idxds = idxtree.database
var en = idxds.GetDataSources()
while (en.hasMoreElements()) {
var ds = en.getNext().QueryInterface(Components.interfaces.nsIRDFDataSource)
if (ds.URI == "rdf:local-store") idxds.RemoveDataSource(ds)}
idxds.AddDataSource(Components.classes["@mozilla.org/rdf/datasource;1?name=in-memory-datasource"].createInstance(Components.interfaces.nsIRDFDataSource))
var rootseq = this.CU.MakeSeq(
idxds,idxds.GetTarget(this.RDF.GetResource("urn:root"), this.ncSubs, true))
ix = doc.getElementsByTagName("index")
index:
for (var i = 0; i < ix.length; ++i) {
var v = ix[i].firstChild.nodeValue
if (!v || v == "") continue
var vs = v.toLowerCase().split(",")
var v0 = vs[0]? vs[0].replace(/^\s*|\s*$/g, "") : null
var v1 = vs[1]? vs[1].replace(/^\s*|\s*$/g, "") : null
if (!v0) continue
var id = ix[i].parentNode.getAttribute("id")
if (!id) continue
var r0 = this.RDF.GetResource(this.chIndex + vs[0].charAt(0))
if (rootseq.IndexOf(r0) < 0) rootseq.AppendElement(r0)
var s0 = idxds.GetTarget(r0, this.ncSubs, true)
if (!s0) {
s0 = this.RDF.GetAnonymousResource()
idxds.Assert(r0, this.ncSubs, s0, true)}
s0 = this.CU.MakeSeq(idxds, s0)
if (!v1) {
var en = s0.GetElements()
while (en.hasMoreElements()) {
var e = en.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
var t = idxds.GetTarget(e, this.ncName, true)
if (t && t.Value == v0) continue index}
var s1 = this.RDF.GetAnonymousResource()
s0.AppendElement(s1)
idxds.Assert(s1, this.ncName, this.RDF.GetLiteral(v0), true)
idxds.Assert(s1, this.ncLink, this.RDF.GetLiteral(spec + "#" + id), true)}
else {
var r1 = this.RDF.GetResource("index:" + v0)
var s1 = idxds.GetTarget(r1, this.ncSubs, true)
if (!s1) {
s1 = this.RDF.GetAnonymousResource()
s0.AppendElement(s1)}
s1 = this.CU.MakeSeq(idxds, s1)
var en = s1.GetElements()
while (en.hasMoreElements()) {
var e = en.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
var t = idxds.GetTarget(e, this.ncName, true)
if (t && t.Value == v1) continue index}
var s2 = this.RDF.GetAnonymousResource()
s1.AppendElement(s2)
idxds.Assert(s2, this.ncName, this.RDF.GetLiteral(v0), true)
idxds.Assert(s2, this.ncLink, this.RDF.GetLiteral(spec + "#" + id), true)}}
idxtree.builder.rebuild()
this.loaded = (--this.todo <= 0)},_alreadyHas: function (ds, res) {
var t = ds.GetTarget(res, this.ncName, true)
if (t) {
dump("CalHelpExtensions: id " + res.Value.replace(/^[^#]*/, "") + " already exists in ToC \n")
dump(" - " + res.Value + "\n")
dump(" - " + t.QueryInterface(Components.interfaces.nsIRDFLiteral).Value + "\n")
return true}
return false},set topic (t) {
if (this.loaded) this.displayTopic(t)
else setTimeout(function () {CalHelpExtensions.topic = t}, 0)}}
CalHelpExtensions.displayTopic = displayTopic
displayTopic = function (topic) {
CalHelpExtensions.topic = topic
CalHelpSidebar.init()
CalHelpExtensions.init()
CalHelpSearch.init()}
